<template lang="pug">
transition(
  name="modal"
  @enter="toggleBodyScroll(true)"
  @leave="toggleBodyScroll(false)"
)
  .modal-mask
    .modal-wrapper(@click.stop="close()" ref="modal")
      .modal-close(@click.prevent="close()")
        span {{ $t('forms.buttons.close') }}
      .modal-container(@click.stop="dummy()")
        .modal-header(v-if="hasHeaderSlot")
          slot(name="header")
        .modal-body(v-if="hasBodySlot")
          slot(name="body")

        .modal-footer(v-if="hasFooterSlot")
          slot(name="footer")
</template>

<script>
import { disableBodyScroll, enableBodyScroll, clearAllBodyScrollLocks } from 'body-scroll-lock'
import eventHub from '../../../utils/eventHub'

export default {
  name: 'Modal',

  computed: {
    hasHeaderSlot () {
      return !!this.$slots.header
    },
    hasBodySlot () {
      return !!this.$slots.body
    },
    hasFooterSlot () {
      return !!this.$slots.footer
    }
  },

  methods: {
    toggleBodyScroll (value) {
      const target = this.$refs.modal
      const BodyScrollOptions = {
        reserveScrollBarGap: true
      }

      if (value) {
        disableBodyScroll(target, BodyScrollOptions)
      } else {
        if (target) {
          enableBodyScroll(target, BodyScrollOptions)
        } else {
          clearAllBodyScrollLocks()
        }
      }
    },

    close () {
      this.toggleBodyScroll(false)
      this.$emit('close')
    },

    dummy () { }
  },

  mounted () {
    const vm = this
    eventHub.$on('global:clearBodyScrollLock', () => {
      vm.toggleBodyScroll(false)
    })
  }
}
</script>
